#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

void BHAssignIntegerConstant(id cfName, int iVal)
{
	id myName = [NSString stringWithFormat:@"PLext::%@", cfName];
	const char *strname = [myName cStringUsingEncoding:NSUTF8StringEncoding];
	SV *sv = get_sv(strname, TRUE);
	sv_setiv(sv, iVal);
}

void BHAssignStringConstant(id cfName, id cfObj)
{
	id myName = [NSString stringWithFormat:@"PLext::%@", cfName];
	const char *strname = [myName cStringUsingEncoding:NSUTF8StringEncoding];
	const char *strbytes = [cfObj cStringUsingEncoding:NSUTF8StringEncoding];
	SV *sv = get_sv(strname, TRUE);
	sv_setpv(sv, strbytes);
}


static void 
add_cocoa_globals()
{
	id p = [[NSAutoreleasePool alloc] init];
	SV *sv;
	
	/*
 	 * =====================================================================
 	 * Panel return values
 	 * =====================================================================
 	 */
	BHAssignIntegerConstant(@"NSAlertDefaultReturn", 1);
	BHAssignIntegerConstant(@"NSAlertAlternateReturn", 0);
	BHAssignIntegerConstant(@"NSAlertOtherReturn", -1);
	BHAssignIntegerConstant(@"NSAlertErrorReturn", -2);

	/*
	 * =====================================================================
	 * Pasteboard return values
	 * =====================================================================
	 */
	BHAssignStringConstant(@"NSGeneralPboard", NSGeneralPboard);
	BHAssignStringConstant(@"NSStringPboardType", NSStringPboardType);
	BHAssignStringConstant(@"NSTabularTextPboardType", NSTabularTextPboardType);
	BHAssignStringConstant(@"NSFileContentsPboardType", NSFileContentsPboardType);
	BHAssignStringConstant(@"NSFilenamesPboardType", NSFilenamesPboardType);
	BHAssignStringConstant(@"NSHTMLPboardType", NSHTMLPboardType);
	BHAssignStringConstant(@"NSRTFDPboardType", NSRTFDPboardType);
	BHAssignStringConstant(@"NSRTFPboardType", NSRTFPboardType);
	BHAssignStringConstant(@"NSURLPboardType", NSURLPboardType);
	BHAssignStringConstant(@"NSVCardPboardType", NSVCardPboardType);
	BHAssignStringConstant(@"NSPDFPboardType", NSPDFPboardType);
	BHAssignStringConstant(@"NSColorPboardType", NSColorPboardType);
	BHAssignStringConstant(@"NSFontPboardType", NSFontPboardType);
	BHAssignStringConstant(@"NSPICTPboardType", NSPICTPboardType);
	BHAssignStringConstant(@"NSPostScriptPboardType", NSPostScriptPboardType);
	BHAssignStringConstant(@"NSRulerPboardType", NSRulerPboardType);
	BHAssignStringConstant(@"NSTIFFPboardType", NSTIFFPboardType);
	
	/*
	 * =====================================================================
	 * Stash manipulation testing
	 * =====================================================================
	 *
	HV *hv = gv_stashpv("PLext", FALSE);
	SV *hkey = newSVpv("NSStringPboardType",0);
	HE *he = hv_fetch_ent(hv, hkey, FALSE, 0);
	STRLEN len;
	char *test = HePV(he, len);
	printf("*** add_cocoa_globals test ***\ntest=%s\n", test);
	*/

	[p release];
}
